'-------------------------------------------------
' Name     : H-Head.bas
' Compiler : PicBasic Pro MicroEngineering Labs 
' Notes    : Humanoid Head software
'-------------------------------------------------

TRISB = %00000000
TRISA = %00001101   

DEFINE OSC 4

include "modedefs.bas"

Led             VAR PORTA.4
Baud            CON N2400
Com_In          VAR PORTA.0
Com_Out         VAR PORTA.1
Control         VAR BYTE
Slider          VAR BYTE
S0              VAR BYTE
S1              VAR BYTE
S2              VAR BYTE
S3              VAR BYTE
S4              VAR BYTE
S5              VAR BYTE
S6              VAR BYTE
S7              VAR BYTE

LOW PORTB.0
LOW PORTB.1
LOW PORTB.2
LOW PORTB.3
LOW PORTB.4
LOW PORTB.5
LOW PORTB.6
LOW PORTB.7
HIGH Led

S0 = 127
S1 = 127 
S2 = 127
S3 = 127
S4 = 127
S5 = 127
S6 = 127
S7 = 127

Start:

    SERIN Com_In,Baud,7,Set_Pos,[255],Slider,Control
    SEROUT  Com_Out,Baud,[Slider,Control]
    
    IF Slider = 0 THEN S0 = Control
    IF Slider = 1 THEN S1 = Control
    IF Slider = 2 THEN S2 = Control
    IF Slider = 3 THEN S3 = Control
    IF Slider = 4 THEN S4 = Control
    IF Slider = 5 THEN S5 = Control
    IF Slider = 6 THEN S6 = Control    
    IF Slider = 7 THEN S7 = Control
    
Set_Pos:

    PULSOUT PORTB.0,S0
    PULSOUT PORTB.1,S1
    PULSOUT PORTB.2,S2
    PULSOUT PORTB.3,S3
    PULSOUT PORTB.4,S4
    PULSOUT PORTB.5,S5
    PULSOUT PORTB.6,S6
    PULSOUT PORTB.7,S7

GOTO Start
